#include "stdafx.h"

class Dataset;
class Statistics;

class Dataset{

public:
	float** mas;
	int pointCount;
	int coordCount;
	bool normToZscores;
	bool weighted;
	float *weights;
	float weightSum;
	bool allocated;

	Dataset(){
		stat = NULL;
		normToZscores = true;
		weighted = false;
		mas = NULL;
		weights = NULL;
		allocated = false;
	};
	~Dataset(){
		if(mas!=NULL){
			if(allocated)
				for(int i=0;i<pointCount;i++) delete [] mas[i];
			if(mas!=NULL)
				delete [] mas;
		}
		if(weights!=NULL) delete [] weights;
	};

	Statistics* stat;

	void loadFromFile(char* fn);
	void loadWeights(char* fn);
	void saveToFile(char* fn);
	void init(int points, int dim);
	void normalize();
	void norm(float *vec);
	void unnorm(float *vec);
	float* getVectorUnNormalized(int i);
	float* getVector(int i);
	void allocate();

	void divideRandomly(Dataset *ds1,Dataset *ds2,float percentage);

};

class Statistics{

public:

	double *Means;
	double *StdDevs;
	double *Mins;
	double *Maxs;
	double totalDispersion;


	Statistics(){
	};
	~Statistics(){
	};


	void calculate(Dataset *d);

};