#include "stdafx.h"
#include <math.h>
#include <time.h>
#include <minmax.h>

#include "utils.h"
#include "dataset.h"
#include "grid.h"
#include "slausolver.h"
#include "elmapalg.h"
#include "princomp.h"

#include <vector.h>

void ElasticMapsAlgorithm::readIniFile(char *fn, int algnum){
	globalEPFactor = 1;
	globalRPFactor = 1;

	vector<ElMapAlgortihmEpoch> epochs;

	FILE *f;
	f = fopen(fn,"r");

	char s[1000];
	char st[1000];
	char gridtype[1000] = "simplerectangular";
	int gridsize1 = 10;
	int gridsize2 = 10;
	int gridsize3 = 10;
	stretchInitCoeffs = new float[3];
	stretchInitCoeffs[0] = (float)0.8;
	stretchInitCoeffs[1] = (float)0.8;
	stretchInitCoeffs[2] = (float)0.8;
	numberOfSteps = 0;
	int minNumInCluster = 5;

	sprintf(st,"#ALG%i",algnum);
	char *tok;
	char *tok1;
	char *sptr;
	while((s!=NULL)&&(strncmp(s,st,strlen(st))!=0)) fgets(s,900,f);
	do{
		sptr = fgets(s,900,f);
		tok = strtok(s," =\t\n");
		if(tok!=NULL){
		//printf("%s -> ",tok);
			tok1 = strtok(NULL," =\t\n");
			if(tok1!=NULL){
				if(strcmp(tok,"algtype")==0){
					strcpy(this->strategytype,tok1);
				}
				if(strcmp(tok,"grid.type")==0){
					strcpy(gridtype,tok1);
				}
				if(strcmp(tok,"grid.size1")==0){
					gridsize1 = atof(tok1);
				}
				if(strcmp(tok,"grid.size2")==0){
					gridsize2 = atof(tok1);
				}
				if(strcmp(tok,"grid.size3")==0){
					gridsize3 = atof(tok1);
				}
				if(strcmp(tok,"grid.minclust")==0){
						minNumInCluster = atoi(tok1);
				}
				if(strcmp(tok,"init.stretch1")==0){
					stretchInitCoeffs[0] = atof(tok1);
				}
				if(strcmp(tok,"init.stretch2")==0){
					stretchInitCoeffs[1] = atof(tok1);
				}
				if(strcmp(tok,"init.stretch3")==0){
					stretchInitCoeffs[2] = atof(tok1);
				}
				if(strcmp(tok,"epoch.id")==0){
					ElMapAlgortihmEpoch *ep = new ElMapAlgortihmEpoch;
					ep->type = 0;
					ep->EP = 1;
					ep->RP = 1;
					ep->epsConvergence = (float)0.01;
					ep->epsConvergenceSLAU = (float)0.01;
					ep->numberOfIterations = 100;
					ep->maxNumberOfIterationsForSLAU = 100;
					ep->extrapolate = 0;
					ep->minimize = true;
					epochs.push_back(*ep);
					numberOfSteps++;
				}
				if(strcmp(tok,"epoch.minimize")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					if(strcmp(tok1,"true")==0)
						ep->minimize = true;
					else
						ep->minimize = false;
				}
				if(strcmp(tok,"epoch.ep")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					ep->EP = atof(tok1);
				}
				if(strcmp(tok,"epoch.rp")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					ep->RP = atof(tok1);
				}
				if(strcmp(tok,"epoch.extrapolate")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					ep->extrapolate = atoi(tok1);
					//printf("%s %s %i\n",tok,tok1,ep.extrapolate);
				}
				if(strcmp(tok,"epoch.eps")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					ep->epsConvergence = atof(tok1);
				}
				if(strcmp(tok,"epoch.epsSLAU")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					ep->epsConvergenceSLAU = atof(tok1);
				}
				if(strcmp(tok,"epoch.numiter")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					ep->numberOfIterations = atoi(tok1);
				}
				if(strcmp(tok,"epoch.numiterSLAU")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					ep->maxNumberOfIterationsForSLAU = atoi(tok1);
				}
				if(strcmp(tok,"adapt.id")==0){
					ElMapAlgortihmEpoch *ep = new ElMapAlgortihmEpoch;
					ep->type = 1;
					ep->EP = 1;
					ep->RP = 1;
					ep->epsConvergence = (float)0.01;
					ep->epsConvergenceSLAU = (float)0.01;
					ep->numberOfIterations = 100;
					ep->maxNumberOfIterationsForSLAU = 100;
					ep->numevery = 1;
					ep->numberOfSteps = 100;
					ep->epsMSE = (float)0.01;
					epochs.push_back(*ep);
					numberOfSteps++;
				}
				if(strcmp(tok,"adapt.type")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					sprintf(ep->adapttype,"%s",tok1);
				}
				if(strcmp(tok,"adapt.numiter")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					ep->numberOfIterations = atoi(tok1);
				}
				if(strcmp(tok,"adapt.numstep")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					ep->numberOfSteps = atoi(tok1);
				}
				if(strcmp(tok,"adapt.numevery")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					ep->numevery = atoi(tok1);
				}
				if(strcmp(tok,"adapt.eps")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					ep->epsConvergence = atof(tok1);
				}
				if(strcmp(tok,"adapt.epsSLAU")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					ep->epsConvergenceSLAU = atof(tok1);
				}
				if(strcmp(tok,"adapt.epsMSE")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					ep->epsMSE = atof(tok1);
				}
				if(strcmp(tok,"adapt.ep")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					ep->EP = atof(tok1);
				}
				if(strcmp(tok,"adapt.rp")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					ep->RP = atof(tok1);
				}
				if(strcmp(tok,"adapt.numevery")==0){
					ElMapAlgortihmEpoch *ep = &epochs[numberOfSteps-1];
					ep->numevery = atoi(tok1);
				}
				//printf("%s\n",tok1);
			}
        }
		}while((s!=NULL)&&(strncmp(s,"#",1)!=0)&&(sptr!=NULL));

	grid = NULL;
	if(strcmp(gridtype,"simplerectangular")==0){
		grid = new SimpleRectangularGrid(gridsize1,gridsize2,data->coordCount);
		setGrid(grid);
	}
	if(strcmp(gridtype,"linear")==0){
		grid = new LinearGrid(gridsize1,data->coordCount);
		setGrid(grid);
	}
	if(strcmp(gridtype,"circle")==0){
		grid = new CircleGrid(gridsize1,data->coordCount);
		setGrid(grid);
	}
	if(strcmp(gridtype,"sphere")==0){
		grid = new SphericalGrid(gridsize1,gridsize2,data->coordCount);
		setGrid(grid);
	}
	if(strcmp(gridtype,"elgraph")==0){
		grid = new ElasticGraph(gridsize1,data->coordCount);
		ElasticGraph *elg = (ElasticGraph*)grid;
		elg->minNumInCluster = minNumInCluster;
		setGrid(grid);
	}
	if(grid == NULL) cout << "No such grid type : " << gridtype << endl;

	steps = new ElMapAlgortihmEpoch*[epochs.size()];
	for(int i=0;i<epochs.size();i++){
		steps[i] = new ElMapAlgortihmEpoch();
		steps[i]->type = epochs[i].type;
		steps[i]->EP = epochs[i].EP;
		steps[i]->epsConvergence = epochs[i].epsConvergence;
		steps[i]->epsConvergenceSLAU = epochs[i].epsConvergenceSLAU;
		steps[i]->extrapolate = epochs[i].extrapolate;
		steps[i]->maxNumberOfIterationsForSLAU = epochs[i].maxNumberOfIterationsForSLAU;
		steps[i]->minimize = epochs[i].minimize;
		steps[i]->numberOfIterations = epochs[i].numberOfIterations;
		steps[i]->RP = epochs[i].RP;
		steps[i]->numberOfSteps = epochs[i].numberOfSteps;
		steps[i]->epsMSE = epochs[i].epsMSE;
		steps[i]->numevery = epochs[i].numevery;
		sprintf(steps[i]->adapttype,"%s",epochs[i].adapttype);
		//delete epochs[i];
	}

	currentEpoch = 0;

	fclose(f);
}


void ElasticMapsAlgorithm::setGrid(Grid *gr){
	grid = gr;
	dimension = gr->dimension;
}

void ElasticMapsAlgorithm::initializeGrid(double *shift,double **vecs,double *disp, int vecnum){ 


	/*for(int ii=0;ii<grid->nodesNum;ii++){
		float *v = grid->Nodes[ii];
		for(int j=0;j<vecnum;j++) printf("%5.2f ",grid->Nodes3D[ii][j]); printf("\n");
	}*/


	// Default way of initialization;
	//if(data->stat==NULL){ Statistics s; s.calculate(data); data->stat=&s;}
	data->stat->calculate(data);
	for(int i=0;i<grid->nodesNum;i++){

		for(int k=0;k<dimension;k++) grid->Nodes[i][k] = (float)shift[k];

		for(int j=0;j<vecnum;j++){
			double d = 0;
			d = disp[j]*data->stat->totalDispersion;

			for(int k=0;k<dimension;k++){
				grid->Nodes[i][k] += (float)(vecs[j][k]*grid->Nodes3D[i][j]*d*stretchInitCoeffs[j]);
			}
		}

	}

	/*for(i=0;i<grid->nodesNum;i++){
		float *v = grid->Nodes[i];
		for(int j=0;j<grid->dimension;j++) printf("%5.2f ",grid->Nodes[i][j]); printf("\n");
	}*/

}

void ElasticMapsAlgorithm::setData(Dataset *d){
	data = d;
	dimension = d->coordCount;
}

void ElasticMapsAlgorithm::setDataTest(Dataset *d){
	datatest = d;
}

void ElasticMapsAlgorithm::setGenManif(Grid *g){
	genManif = g;
}


void ElasticMapsAlgorithm::setSolver(SLAUSolver *s){
	solver = s;
	solver->dimension = grid->nodesNum;
}

//void ElasticMapsAlgorithm::setBasis(PCAMethod *bas){
//	basis = bas;
//}


int  ElasticMapsAlgorithm::calcTaxons(){

	long cl = clock();
	grid->MakeNodesCopy();
	//printf("For make copy : %i",clock()-cl);
	grid->calcTaxons(taxons,data);
	return clock()-cl;
}

double ElasticMapsAlgorithm::calcMSE(){
	return grid->calcMSE(data,taxons);
}

double ElasticMapsAlgorithm::calcMSEtest(){
	double res = 0;
	if(datatest!=NULL){
		vector<vector<int> > v;
		grid->calcTaxons(v,datatest);
		res = grid->calcMSE(datatest,v);
	}
	return res;
}


long ElasticMapsAlgorithm::calcSystemMatrix(char *fn){

		long cl = clock();

		float ep = globalEPFactor*pow((double)grid->nodesNum,(double)(2-grid->intDim)/(double)grid->intDim)/100; 
		float rp = globalRPFactor*pow((double)grid->nodesNum,(double)(2-grid->intDim)/(double)grid->intDim)/pow(10.0,(double)grid->intDim);  

		// first: diagonal addings

		solver->dimension = grid->nodesNum;
		solver->initMatrix();

		//float *diag = new float[grid->nodesNum];
		for(int i=0;i<grid->nodesNum;i++){
			double d = 0;
			if(data->weighted){
				for(int k=0;k<taxons[i].size();k++)
					d+=data->weights[taxons[i][k]];
				d/=data->weightSum;
			}
			else
				d = (double)taxons[i].size()/data->pointCount;
			if(globalEPFactor<0) d = - d;
			//cout << taxons[i].size() << "->" << d << endl;
			solver->addToMatrixElement(i,i,d);
		}
		// now all the rest

		//for(i=0;i<grid->edgesNum;i++) cout << grid->EP[i] << " "; cout << endl;
		//for(i=0;i<grid->ribsNum;i++) cout << grid->RP[i] << " "; cout << endl;
		
		int k1,k2,k3;
		for(i=0;i<grid->edgesNum;i++){
			k1 = grid->Edges[i][0];
			k2 = grid->Edges[i][1];
			solver->addToMatrixElement(k1,k1,ep*grid->EP[i]);
			solver->addToMatrixElement(k2,k2,ep*grid->EP[i]);
			solver->addToMatrixElement(k1,k2,-ep*grid->EP[i]);
			solver->addToMatrixElement(k2,k1,-ep*grid->EP[i]);
			//EMatrix[k1][k1] = EMatrix[k1][k1]+EP[i];
			//EMatrix[k2][k2] = EMatrix[k2][k2]+EP[i];
			//EMatrix[k1][k2] = EMatrix[k1][k2]-EP[i];
			//EMatrix[k2][k1] = EMatrix[k2][k1]-EP[i];
		};

		for(i=0;i<grid->ribsNum;i++){
			k1 = grid->Ribs[i][1];
			k2 = grid->Ribs[i][0];
			k3 = grid->Ribs[i][2];

			solver->addToMatrixElement(k1,k1,rp*grid->RP[i]);
			solver->addToMatrixElement(k2,k2,4*rp*grid->RP[i]);
			solver->addToMatrixElement(k3,k3,rp*grid->RP[i]);

			solver->addToMatrixElement(k1,k2,-2*rp*grid->RP[i]);
			solver->addToMatrixElement(k2,k1,-2*rp*grid->RP[i]);
			solver->addToMatrixElement(k2,k3,-2*rp*grid->RP[i]);
			solver->addToMatrixElement(k3,k2,-2*rp*grid->RP[i]);			

			solver->addToMatrixElement(k1,k3,rp*grid->RP[i]);			
			solver->addToMatrixElement(k3,k1,rp*grid->RP[i]);			

			/*RMatrix[k1][k1] = RMatrix[k1][k1]+RP[i];
			RMatrix[k2][k2] = RMatrix[k2][k2]+4*RP[i];
			RMatrix[k3][k3] = RMatrix[k3][k3]+RP[i];

			RMatrix[k1][k2] = RMatrix[k1][k2]-2*RP[i];
			RMatrix[k2][k1] = RMatrix[k2][k1]-2*RP[i];

			RMatrix[k2][k3] = RMatrix[k2][k3]-2*RP[i];
			RMatrix[k3][k2] = RMatrix[k3][k2]-2*RP[i];

			RMatrix[k1][k3] = RMatrix[k1][k3]+RP[i];
			RMatrix[k3][k1] = RMatrix[k3][k1]+RP[i];*/
		};

	//delete [] diag;
	solver->createMatrix();
	solver->createPreconditioner();
	//solver->saveMatrix(fn);

	return clock() - cl;
}



long ElasticMapsAlgorithm::calcRightHandVector(int coord,double*vec){
  long cl = clock();
  for(int i=0;i<grid->nodesNum;i++){
  vec[i] = 0;
  for(int j=0;j<taxons[i].size();j++) 
       // cout << taxons[i][j] << "//"; 
	   if(!data->weighted)
			vec[i] += data->mas[taxons[i][j]][coord]; 
	   else
			vec[i] += data->mas[taxons[i][j]][coord]*data->weights[taxons[i][j]]; 
  //cout << "*" << endl; }; 
  };
  for(i=0;i<grid->nodesNum;i++)
		if(!data->weighted)
            vec[i] = vec[i]/(data->pointCount);
		else
			vec[i] = vec[i]/data->weightSum;
  //cout << "fini" << endl;
  return clock() - cl;
}


void ElasticMapsAlgorithm::saveRightHandVector(double*vec,char *fn){
	FILE *f;
	f = fopen(fn,"w");
	if(f!=NULL){
		// format???
	}else{ printf("System fault: can not open %s",fn); }
}


void ElasticMapsAlgorithm::doit(){
	printf("Strategy: %s\n",strategytype);
	if(strcmp(strategytype,"epoch")==0) {  doTheEpochStrategy();} 
}

// Epoch strategy


void ElasticMapsAlgorithm::doTheEpochStrategy(){
	int l = 1;
	while(l>=0){
		if(currentEpoch>=numberOfSteps) break;
		if(steps[this->currentEpoch]->type==0)
			l = proceedToTheNextEpoch();
		else
		if(steps[this->currentEpoch]->type==1){
			ElMapAlgortihmEpoch *epoch = steps[this->currentEpoch];
			calcTaxons();
			for(int i=0;i<epoch->numberOfSteps;i++){
				cout << "Adaptation step: " << (i+1) << endl;
				double mse1 = calcMSE();
				if(strcmp(epoch->adapttype,"grow")==0)
					grid->adaptateGrow(taxons,epoch->numevery);
				if(strcmp(epoch->adapttype,"break")==0)
					grid->adaptateBreak(taxons,data);
				l = proceedToTheNextEpoch();
				calcTaxons();
				double mse2 = calcMSE();
				currentEpoch--;
				if(fabs(mse1-mse2)<epoch->epsMSE) 
					break;
			}
		currentEpoch++;
		//if(currentEpoch>=numberOfSteps) l = -1; else l = 1;
		}
	}
}

long ElasticMapsAlgorithm::proceedToTheNextEpoch(){

	long cl = clock();
	if(this->currentEpoch>=this->numberOfSteps){
		return -1;
	}else{

	ElMapAlgortihmEpoch *epoch = steps[this->currentEpoch];

	currentEpoch++;

	this->globalEPFactor = epoch->EP;
	this->globalRPFactor = epoch->RP;
	//cout << "EP: " << epoch->EP << " RP: " << epoch->RP << endl;

	float **MemNodesPos = new float*[grid->nodesNum];
	for(int i=0;i<grid->nodesNum;i++) { 
		MemNodesPos[i] = new float[grid->dimension];
		for(int j=0;j<grid->dimension;j++) {
			MemNodesPos[i][j] = grid->Nodes[i][j];
			//cout << "Node: " <<  grid->Nodes[i][j] << " " << endl;
		}
	}

	double *rightHandVector = new double[grid->nodesNum];
	double *solution = new double[grid->nodesNum];

	if(epoch->minimize)
	for(i=0;i<epoch->numberOfIterations;i++){

		long cl2 = calcTaxons();
		long cl3 = calcSystemMatrix("matrix");
		//solver->readMatrix("matrix");

		cl = clock();
		
		//printf("Eps %f EpsSlau %f\n",epoch->epsConvergence,epoch->epsConvergenceSLAU);		
		for(int j=0;j<grid->dimension;j++){
			for(int k=0;k<grid->nodesNum;k++)
				solution[k] = grid->Nodes[k][j];
			long cl3 = calcRightHandVector(j,rightHandVector);
			// cout << cl3 << endl;
			solver->setSolution(solution);
			solver->setVector(rightHandVector);

			//solver->saveMatrix("matrix");
			//solver->saveVector("matrix");
			
			long cl1 = clock();
	        //printf("Eps %f EpsSlau %f\n",epoch->epsConvergence,epoch->epsConvergenceSLAU);
			solver->solve(epoch->epsConvergenceSLAU,epoch->maxNumberOfIterationsForSLAU);
			//cout << " Coord :\t" << j << "\tTime :\t" << clock()-cl1 << endl;
			//cout << clock()-cl1 << endl;
			
			for(k=0;k<grid->nodesNum;k++)
				grid->Nodes[k][j] = (float)solver->solution[k];
		}

			// now calculating how far it is shifted
		float diff = 0;
		for(int k=0;k<grid->nodesNum;k++){
			for(j=0;j<grid->dimension;j++){
				diff+=(float)fabs(MemNodesPos[k][j]-grid->Nodes[k][j]);
				//cout << "df " << fabs(MemNodesPos[k][j]-grid->Nodes[k][j]) << endl;
				MemNodesPos[k][j] = grid->Nodes[k][j];
			}
		}
		diff/=(float)grid->dimension;
		diff/=(float)grid->nodesNum;

		char s[1000];
		sprintf(s,"");
		if(genManif!=NULL){
			double d = 0;
			d = grid->MSEDistanceTo(genManif,0);
			sprintf(s," GMSE %5.4f ",d);
		}
		
		if(datatest!=NULL)
		cout << "Ep: " << currentEpoch << " It: " << i <<  " MSE: " << calcMSE() << "/" << calcMSEtest() << s << " Df: " << diff << " Time: "<< clock()-cl << "+(" << cl2 << "," << cl3<< ")" << endl;
		else
		cout << "Ep: " << currentEpoch << " It: " << i <<  " MSE: " << calcMSE() << s << " Df: " << diff << " Time: "<< clock()-cl << "+(" << cl2 << "," << cl3<< ")" << endl;

		if(diff<=epoch->epsConvergence) break;
	}

	delete [] solution;
	delete [] rightHandVector;
	solver->solution = NULL;
	solver->vector = NULL;

	for(i=0;i<grid->nodesNum;i++) delete [] MemNodesPos[i];
	delete [] MemNodesPos;

	//printf("Extrapolate %i\n",epoch->extrapolate);
	for(i=0;i<epoch->extrapolate;i++){
		switch(grid->type){
		case 0: {
			SimpleRectangularGrid *g = (SimpleRectangularGrid *)grid;
			g->extrapolate(); }
		break;
		case 2: { 
			LinearGrid *g = (LinearGrid *)grid;
			g->extrapolate(); }
		break;
		};
	}

	return clock()- cl;
	}
}

void ElasticMapsAlgorithm::doGraphConstruct(){
	ElasticGraph *gr = (ElasticGraph *)grid;
	gr->KMeansInitialization(data,10,0.01);
	gr->localDipoles(data);
	gr->synchronize();
	gr->connectGraph();
	doTheEpochStrategy();
}


