#include "stdafx.h"
#include "vector.h"

class PCAMethod;
class Dataset;
class Grid;
class SLAUSolver;

struct ElMapAlgortihmEpoch{
int type; // 0 - epoch, 1 - adaptation
char adapttype[1000];
float EP;
float RP;
float epsConvergence;
float epsConvergenceSLAU;
float epsMSE;
int numberOfIterations;
int numberOfSteps;
int maxNumberOfIterationsForSLAU;
int extrapolate;
int numevery;
bool minimize;
};

class ElasticMapsAlgorithm{

public:

int dimension;

void readIniFile(char *,int);

int currentEpoch;
int numberOfSteps;
float *stretchInitCoeffs;
float globalEPFactor;
float globalRPFactor;
ElMapAlgortihmEpoch **steps;
char strategytype[100];

Grid *genManif;

ElasticMapsAlgorithm(){
	 strcpy(strategytype,"epoch");
	 datatest = NULL;
	 genManif = NULL;
};

Grid *grid;
void setGrid(Grid *gr);
void initializeGrid(double *shift,double **vecs,double *disp, int vecnum);

Dataset *data;
Dataset *datatest;
void setData(Dataset *d);
void setDataTest(Dataset *d);
void setGenManif(Grid *g);

SLAUSolver *solver;
void setSolver(SLAUSolver *s);

PCAMethod *basis;
void setBasis(PCAMethod *bas);

vector<vector<int> >taxons;
int  calcTaxons();
double calcMSE();
double calcMSEtest();

long calcSystemMatrix(char *fn);
long calcRightHandVector(int coord,double*vec);
void saveRightHandVector(double*vec,char *fn);

void doit();
void doTheEpochStrategy();
long proceedToTheNextEpoch();

void doGraphConstruct();

};


