#include "stdafx.h"
#include "grid.h"
#include "math.h"
#include "string.h"
#include "vector.h"
#include "dataset.h"
#include "utils.h"
#include "princomp.h"


void Grid::loadFromFile(char* fn){
};

void Grid::loadNodesFromFile(char *fn){
	FILE *f;
	f = fopen(fn,"r");
	char s[10000];
	char *sptr;
	char *tok;
	float *node = new float[dimension];
	if(f!=NULL){
		while((sptr!=NULL)&&(s!=NULL)){
			sptr = fgets(s,10000,f);
			if((sptr!=NULL)&&(s!=NULL)){
			//cout << "s = " << s << " " << endl;
			tok = strtok(s,"\t "); 
			//cout << " tok: " << tok << endl;
			if(tok!=NULL){
			node[0] = atof(tok); //cout << node[0] << " ";
			//cout << "Read toks : ";
			for(int i=1;i<dimension;i++) { tok = strtok(NULL," \t"); node[i] = atof(tok); /*cout << node[i] << " ";*/ } //cout << endl;
			vector<float> nd;
			for(i=0;i<dimension;i++) nd.push_back(node[i]);
			Nodes.push_back(nd);
			vector<float> nd3;
			for(i=0;i<3;i++) { if(i<dimension) nd3.push_back(node[i]); else nd3.push_back(0); }
			Nodes3D.push_back(nd3);
			}
			}
		};
	delete [] node;
	nodesNum = Nodes.size();
	ribsNum = Ribs.size();
	edgesNum = Edges.size();
	trianglesNum = Triangles.size();
	}else{ cout<< "Can not open file " << fn << endl; exit(1);};
};



void Grid::saveToFile(char* fn,char *dat){
	FILE *f;
	char *s;
	s = new char[100];
	f = fopen(fn,"w");
	if(f!=NULL){
		fprintf(f,"# DATAFILENAME\n");
		fprintf(f,"%s.ved\n\n",dat);
		fprintf(f,"# TABLENAME\n");
        fprintf(f,"%s.vet\n\n",dat);		
		fprintf(f,"# DIMENSION\n%i\n\n",dimension);
		fprintf(f,"# INITIALIZATION\nMAINCOMP 0.5 30 FALSE\n\n");
		fprintf(f,"# ELASTICITY\n1 1\n\n");
		fprintf(f,"# DISCRETE\nFALSE\n\n");
		fprintf(f,"# SMOOTHNESS\n1\n\n");
		fprintf(f,"# TONES\n0\n\n");
		fprintf(f,"# GRIDTYPE\n");
		switch(type){
		case 0: 
			fprintf(f,"RECTANGULAR\n10 10\n\n");
			//SimpleRectangularGrid *gr = (SimpleRectangularGrid)this;
			//fprintf(f,"%i %i\n",gr->colCount,gr->rowCount); 
		break;
		case 1:
			fprintf(f,"RECTANGULAR\n10 10\n\n");
		break;
		case 2:
			fprintf(f,"RECTANGULAR\n10 10\n\n");
		break;
		case 3:
			fprintf(f,"RECTANGULAR\n10 10\n\n");
		break;
		case 4:
			fprintf(f,"RECTANGULAR\n10 10\n\n");
		break;
		}
		fprintf(f,"# NODES\n%i\n\n",nodesNum);
		fprintf(f,"# EDGES\n%i\n\n",edgesNum);
		fprintf(f,"# RIBS\n%i\n\n",ribsNum);
		fprintf(f,"# TRIANGLES\n%i\n\n",trianglesNum);
		fprintf(f,"# GRIDNODES\n");
		for(int k=0;k<nodesNum;k++){
			for(int i=0;i<dimension;i++){
				fprintf(f,"%10.8f ",Nodes[k][i]);		
			}
		fprintf(f,"\n");
		}
		fprintf(f,"\n# GRIDEDGES\n");
		for(k=0;k<edgesNum;k++){
			for(int i=0;i<2;i++){
				fprintf(f,"%i ",Edges[k][i]);		
			}
		fprintf(f,"\n");
		}
		fprintf(f,"\n# GRIDRIBS\n");
		for(k=0;k<ribsNum;k++){
			for(int i=0;i<3;i++){
				fprintf(f,"%i ",Ribs[k][i]);		
			}
		fprintf(f,"\n");
		}
		fprintf(f,"\n# GRIDTRIANGLES\n");
		for(k=0;k<trianglesNum;k++){
			for(int i=0;i<3;i++){
				fprintf(f,"%i ",Triangles[k][i]);		
			}
		fprintf(f,"\n");
		}
		fprintf(f,"\n# GRIDNODES2D\n");
		for(k=0;k<nodesNum;k++){
			for(int i=0;i<2;i++){
				fprintf(f,"%10.8f ",Nodes3D[k][i]);		
			}
		fprintf(f,"\n");
		}
		fprintf(f,"\n# GRIDEP\n"); 
		for(k=0;k<edgesNum;k++) fprintf(f,"%10.5f ",EP[k]);
		fprintf(f,"\n\n");
		fprintf(f,"# GRIDRP\n"); 
		for(k=0;k<ribsNum;k++) fprintf(f,"%10.5f ",RP[k]);
		fprintf(f,"\n\n");

		fclose(f);
	}else{
		printf("Can not open file for writing: %s",fn);
	}
};


void Grid::generate(){
};
void Extendable::extrapolate(){
}
void Grid::extrapolate(){
}

void Grid::allocate(){
  /*Nodes = new float*[nodesNum];
  for(int i=0;i<nodesNum;i++){
  		Nodes[i] = new float[dimension];
  }
  Nodes3D = new float*[nodesNum];
  for(i=0;i<nodesNum;i++){
  	Nodes3D[i] = new float[3];
  }
  //Nodes3D = new float[colCount*rowCount][3];
  Edges = new int*[edgesNum];
  EP = new float[edgesNum];
  for(i=0;i<edgesNum;i++){
		Edges[i] = new int[2];
		EP[i] = 1;
  }
  Ribs = new int*[ribsNum];
  RP = new float[ribsNum];
  for(i=0;i<ribsNum;i++){
		Ribs[i] = new int[3];
		RP[i] = 1;
  }
  Triangles = new int*[trianglesNum];
  for(i=0;i<trianglesNum;i++){
		Triangles[i] = new int[3];
  }*/
  for(int i=0;i<nodesNum;i++){
  		vector<float> vf;
		for(int j=0;j<dimension;j++) (vf).push_back(0.0);
		Nodes.push_back(vf);
  }
  for(i=0;i<nodesNum;i++){
  		vector<float> vf;
		for(int j=0;j<3;j++) (vf).push_back(0.0);
		Nodes3D.push_back(vf);
  }
  for(i=0;i<edgesNum;i++){
	    vector<int> vi;
		for(int j=0;j<2;j++) (vi).push_back(0);
		Edges.push_back(vi);
		EP.push_back(1.0);
  }
  for(i=0;i<ribsNum;i++){
	    vector<int> vi;
		for(int j=0;j<3;j++) (vi).push_back(0);
		Ribs.push_back(vi);
		RP.push_back(1.0);
  }
  for(i=0;i<trianglesNum;i++){
	    vector<int> vi;
		for(int j=0;j<3;j++) (vi).push_back(0);
		Triangles.push_back(vi);
  }
  NodesCopy = NULL;
  NodesCopy2 = NULL;
  MakeNodesCopy();
}

void Grid::MakeNodesCopy(){
  if(NodesCopy!=NULL) delete [] NodesCopy;
  NodesCopy = new float[nodesNum*dimension];

  if(NodesCopy2!=NULL){
	  for(int i=0;i<n2;i++)
		  delete [] NodesCopy2[i];
	  delete [] NodesCopy2;
  }

  for(int i=0;i<nodesNum;i++)
	for(int j=0;j<dimension;j++) 
		NodesCopy[i*dimension+j] = Nodes[i][j];

  NodesCopy2 = new float*[nodesNum];
  for(i=0;i<nodesNum;i++){
		float *v = new float[dimension];
		NodesCopy2[i] = v;
		for(int j=0;j<dimension;j++) 
			NodesCopy2[i][j] = Nodes[i][j];
  }
  n2 = nodesNum;

}

void Grid::free(){
/*	  for(int i=0;i<nodesNum;i++){
		delete [] Nodes[i];
	}
  delete [] Nodes;
  for(i=0;i<nodesNum;i++){
		delete [] Nodes3D[i];
  }
  delete [] Nodes3D;
  for(i=0;i<edgesNum;i++){
		delete [] Edges[i];
  }
  delete [] Edges;
  for(i=0;i<ribsNum;i++){
		delete [] Ribs[i];
  }
  delete [] Ribs;
  for(i=0;i<trianglesNum;i++){
		delete [] Triangles[i];
  }
  delete [] Triangles;
  delete [] EP;
  delete [] RP;
*/
  for(int i=0;i<nodesNum;i++){
		Nodes[i].clear();
		Nodes3D[i].clear();
	}
  Nodes.clear();
  Nodes3D.clear();
  for(i=0;i<edgesNum;i++){
		Edges[i].clear();
  }
  Edges.clear();
  for(i=0;i<ribsNum;i++){
		Ribs[i].clear();
  }
  Ribs.clear();
  for(i=0;i<trianglesNum;i++){
		Triangles[i].clear();
  }
  Triangles.clear();
  EP.clear();
  RP.clear();
  nodesIndex.clear();
  if(NodesCopy!=NULL) delete [] NodesCopy;
  if(NodesCopy2!=NULL) delete [] NodesCopy2;
  NodesCopy = NULL;
  NodesCopy2 = NULL;
}

//void Grid::adaptate(vector<vector<int> > taxons, int degree){
//
//};

double Grid::MSEDistanceTo(Grid *g, int sil){
	double res = 0;
	g->MakeNodesCopy();
	float *v = new float[dimension];
	for(int i=0;i<nodesNum;i++){
		for(int k=0;k<dimension;k++) v[k] = Nodes[i][k];
		float minr = (float)MAX_VALUE;
		int minj = -1;
		for(int j=0;j<g->nodesNum;j++){
			float r = squareEuclDistance(g->NodesCopy,j*dimension,v,g->dimension);
			if(r<minr){ minr=r; minj = j; }
		}
	res+=minr;
	};
	return sqrt(res/nodesNum);
};

void Grid::divideEdgeInHalf(int num, int adapt){

	vector<float> newNode;
	vector<float> newNode3D;
	for(int i=0;i<dimension;i++){
		float f = (float)0.5*(Nodes[Edges[num][0]][i]+Nodes[Edges[num][1]][i]);
		newNode.push_back(f);
	}
	for(i=0;i<3;i++){
		float f = (float)0.5*(Nodes3D[Edges[num][0]][i]+Nodes3D[Edges[num][1]][i]);
		newNode3D.push_back(f);
	}

	int node1 = Edges[num][0];
	int node2 = Edges[num][1];
	int node3 = nodesNum;
	
	Nodes.push_back(newNode);
	Nodes3D.push_back(newNode3D);

	int node11 = -1;
	int node22 = -1;
	vector<int> rbs;
	for(i=0;i<ribsNum;i++){
		if(Ribs[i][0]==node1) { 
			rbs.push_back(i); 
			if(Ribs[i][1]==node2) node11 = Ribs[i][2]; else node11 = Ribs[i][1];
		}
		if(Ribs[i][0]==node2) {
			rbs.push_back(i);
			if(Ribs[i][1]==node1) node22 = Ribs[i][2]; else node22 = Ribs[i][1];
		}
	}
	
	Edges.erase(Edges.begin()+num);
	float memep = EP[num];
	EP.erase(EP.begin()+num);
	if(rbs.size()==2)
		if(rbs[0]>rbs[1]) { int temp = rbs[1]; rbs[1] = rbs[0]; rbs[0] = temp; };
	if(rbs.size()==2){
		Ribs.erase(Ribs.begin()+rbs[1]);
		RP.erase(RP.begin()+rbs[1]);
	}
	if(rbs.size()>=1){
		Ribs.erase(Ribs.begin()+rbs[0]);
		RP.erase(RP.begin()+rbs[0]);
	}
	vector<int> rib1; 
	vector<int> rib2; 
	vector<int> rib3; 
	vector<int> edge1; 
	vector<int> edge2; 
	
	if(node11!=-1){
		rib1.push_back(node1); rib1.push_back(node11); rib1.push_back(node3);
		Ribs.push_back(rib1);
		RP.push_back(1);
	}
	rib2.push_back(node3); rib2.push_back(node1); rib2.push_back(node2);
	Ribs.push_back(rib2); RP.push_back(1);
	if(node22!=-1){
		rib3.push_back(node2); rib3.push_back(node3); rib3.push_back(node22);
		Ribs.push_back(rib3);
		RP.push_back(1);
	}
	edge1.push_back(node1); edge1.push_back(node3); 
	edge2.push_back(node3); edge2.push_back(node2);

	Edges.push_back(edge1); 
	Edges.push_back(edge2);

	if(adapt==1) memep*=2; else memep=1;
	EP.push_back(memep); 
	EP.push_back(memep);

	nodesNum=Nodes.size();
	edgesNum=Edges.size();
	ribsNum=Ribs.size();
};

void Grid::projectPoint(float *point, float *res){
float r, minr = 10000000;
int minj = -1;
		for(int j=0;j<nodesNum;j++){
			     r = squareEuclDistance(NodesCopy,j*dimension,point,dimension);
			if(r<minr){ minr=r; minj = j; }
		}
		float u,v,d,mind = 10000000, minu, minv;
		int mini = -1;
		for(int i=0;i<Triangles.size();i++){
			if((Triangles[i][0]==minj)||(Triangles[i][1]==minj)||(Triangles[i][2]==minj)){
				float *p1 = NodesCopy2[Triangles[i][0]];
				float *p2 = NodesCopy2[Triangles[i][1]];
				float *p3 = NodesCopy2[Triangles[i][2]];
				d = projectOnTriangle(point,p1,p2,p3,dimension,u,v);
				if(d<mind){ mind = d; mini = i; minu = u; minv = v;}
			}
		}
		if(mini>=0){
			float x0,x1,x2;
			for(i=0;i<3;i++){
				x0 = Nodes3D[Triangles[mini][0]][i];
				x1 = Nodes3D[Triangles[mini][1]][i];
				x2 = Nodes3D[Triangles[mini][2]][i];
				res[i] = x0 + minu*(x1-x0) + minv*(x2-x0);
			}
		}
}

void Grid::saveProjections(char *fn, Dataset *ds){
	FILE *f;
	f = fopen(fn,"w");
	if(f!=NULL){
		MakeNodesCopy();
		float *proj = new float[3];
		for(int i=0;i<ds->pointCount;i++){
			float *v = ds->getVector(i);
			projectPoint(v,proj);
			fprintf(f,"%f\t%f\t%f\n",proj[0],proj[1],proj[2]);
		}
		delete [] proj;
	}else{
		printf("Can not open file for writing %s\n",fn);
	}
}

void Grid::copyfrom(Grid &sgr){
	for(int i=0;i<nodesNum;i++){
		for(int j=0;j<dimension;j++) Nodes[i][j] = sgr.Nodes[i][j];
		for(j=0;j<3;j++) Nodes3D[i][j] = sgr.Nodes3D[i][j];
	}
	for(i=0;i<edgesNum;i++){
		Edges[i][0] = sgr.Edges[i][0];
		Edges[i][1] = sgr.Edges[i][1];
		EP[i] = sgr.EP[i];
	}
	for(i=0;i<ribsNum;i++){
		Ribs[i][0] = sgr.Ribs[i][0];
		Ribs[i][1] = sgr.Ribs[i][1];
		Ribs[i][2] = sgr.Ribs[i][2];
		RP[i] = sgr.RP[i];
	}
	for(i=0;i<trianglesNum;i++){
		Triangles[i][0] = sgr.Triangles[i][0];
		Triangles[i][1] = sgr.Triangles[i][1];
		Triangles[i][2] = sgr.Triangles[i][2];
	}
}

void SimpleRectangularGrid::generate(){
  //printf("generating\n");

  nodesNum = colCount*rowCount;
  edgesNum = 2*colCount*rowCount-colCount-rowCount;
  ribsNum = 2*(colCount*rowCount-colCount-rowCount);
  trianglesNum = 2*(rowCount-1)*(colCount-1);
  intDim = 2;
  
  allocate();

  for(int i=0;i<rowCount;i++)
    for(int j=0;j<colCount;j++) {
      Nodes3D[colCount*i+j][0]=float((float)i/(rowCount-1)*2.0-1.0);
      if(colCount==1) Nodes3D[colCount*i+j][1]=0;
      else
	  Nodes3D[colCount*i+j][1]=float((float)j/(colCount-1)*2.0-1.0);
      Nodes3D[colCount*i+j][2]=0;
	  }

  int k=0;
  for(i=0;i<rowCount;i++)
     for(int j=0;j<colCount;j++) {
      if(j<colCount-1) {
       Edges[k][0]=colCount*i+j;
       Edges[k][1]=colCount*i+j+1;
       k++;
      }
      if(i<rowCount-1) {
       Edges[k][0]=i*colCount+j;
       Edges[k][1]=(i+1)*colCount+j;
       k++;
      }
     }

   k=0;
   for(i=0;i<rowCount;i++)
    for(int j=0;j<colCount;j++) {
       if(j<colCount-2) {
        Ribs[k][0]=colCount*i+j+1;
        Ribs[k][1]=colCount*i+j;
        Ribs[k][2]=colCount*i+j+2;
        k++;
       }
       if(i<rowCount-2) {
        Ribs[k][0]=(i+1)*colCount+j;
        Ribs[k][1]=i*colCount+j;
        Ribs[k][2]=(i+2)*colCount+j;
        k++;
       }
      }

    k=0;
    for(i=0;i<colCount-1;i++)
     for(int j=0;j<rowCount-1;j++) {
      Triangles[k][0]=colCount*j+i;
      Triangles[k][1]=colCount*j+i+1;
      Triangles[k][2]=colCount*(j+1)+i;
      k++;
      Triangles[k][0]=colCount*(j+1)+i+1;
      Triangles[k][1]=colCount*j+i+1;
      Triangles[k][2]=colCount*(j+1)+i;
      k++;
     }
};

void Grid::getDistancesToCentroids(double *mas, Dataset *dat, vector<vector<int> > taxons){
	float *vec = new float[dimension];
	for(int i=0;i<nodesNum;i++){
		for(int j=0;j<dimension;j++) {
			vec[j] = (float)0;
			for(int k=0;k<taxons[i].size();k++)
				vec[j]+=dat->mas[taxons[i][k]][j];
			if(taxons[i].size()==0)
			vec[j]=0;
			else
			vec[j]/=taxons[i].size();
		}
		mas[i] = (squareEuclDistance(Nodes[i],vec,dimension));
		mas[i] = mas[i]*mas[i];
	}
	delete [] vec;
};

void Grid::fixEElasticity(int mode){

	int i;

	float minl = 10000000;
	float maxl = -1;
	float meanl = 0;
	for(i=0;i<Edges.size();i++){
		float l = 0;
		for(int k=0;k<dimension;k++){ 
			float h = 0;
			if(mode==0)if(k<=3)
				h = Nodes3D[Edges[i][0]][k] - Nodes3D[Edges[i][1]][k];
			if(mode==1)
				h = Nodes[Edges[i][0]][k] - Nodes[Edges[i][1]][k];;
			l+= h*h;
		}
	if(l>maxl) maxl = l;
	if(l<minl) minl = l;
	meanl+=l;
	}
	meanl/=Edges.size();
	for(i=0;i<Edges.size();i++){
		float l = 0;
		for(int k=0;k<dimension;k++){ 
			float h = 0;
			if(mode==0)
				h = Nodes3D[Edges[i][0]][k] - Nodes3D[Edges[i][1]][k];
			if(mode==1)
				h = Nodes[Edges[i][0]][k] - Nodes[Edges[i][1]][k];;
			l+= h*h;
		}
	//EP[i] = 1.5 - (l-minl)/(maxl-minl);
	EP[i] = meanl/l;
	}
};

void Grid::fixRElasticity(int mode){

	int i;
	float minl = 10000000;
	float maxl = -1;
	float meanl = 0;

	for(i=0;i<Ribs.size();i++){
		float l = 0;
		for(int k=0;k<dimension;k++){ 
			float h;
			if(mode==0)if(k<=3)
				h = Nodes3D[Ribs[i][1]][k] + Nodes3D[Ribs[i][2]][k] - 2*Nodes3D[Ribs[i][0]][k];
			if(mode==1)
				h = Nodes[Ribs[i][1]][k] + Nodes[Ribs[i][2]][k] - 2*Nodes3D[Ribs[i][0]][k];
			l+= h*h;
		}
	if(l>maxl) maxl = l;
	if(l<minl) minl = l;
	meanl+=l;
	}
	meanl/=Ribs.size();
	for(i=0;i<Ribs.size();i++){
		float l = 0;
		for(int k=0;k<dimension;k++){ 
			float h;
			if(mode==0)if(k<=3)
				h = Nodes3D[Ribs[i][1]][k] + Nodes3D[Ribs[i][2]][k] - 2*Nodes3D[Ribs[i][0]][k];
			if(mode==1)
				h = Nodes[Ribs[i][1]][k] + Nodes[Ribs[i][2]][k] - 2*Nodes3D[Ribs[i][0]][k];
			l+= h*h;
		}
	//RP[i] = 1.5 - (l-minl)/(maxl-minl);
	RP[i] = meanl/l;
	}
};

SimpleRectangularGrid::SimpleRectangularGrid(int cols,int rows,int dim){
	rowCount = rows;
	colCount = cols;
	dimension = dim;
	type = 0;
	generate();
};


void SimpleRectangularGrid::extrapolate(){
	printf("Extrapolation step... \n");
	SimpleRectangularGrid sgr(colCount+2,rowCount+2,dimension);	
	for(int i=0;i<nodesNum;i++){
		int row = (int)((double)i/colCount);
		int col = i-row*colCount;
		row++; col++;
		int j = row*(colCount+2)+col;
		for(int k=0;k<dimension;k++) sgr.Nodes[j][k] = Nodes[i][k];
	}
	for(i=0;i<sgr.nodesNum;i++){
		int row = (int)((double)i/sgr.colCount);
		int col = i-row*sgr.colCount;
		if((row==0)&&(col!=0)&&(col!=sgr.colCount-1)){
			int i1 = i+sgr.colCount;
			int i2 = i+2*sgr.colCount;
			for(int k=0;k<dimension;k++) sgr.Nodes[i][k] = 2*sgr.Nodes[i1][k]-sgr.Nodes[i2][k];
		}
		if((row==sgr.rowCount-1)&&(col!=0)&&(col!=sgr.colCount-1)){
			int i1 = i-sgr.colCount;
			int i2 = i-2*sgr.colCount;
			for(int k=0;k<dimension;k++) sgr.Nodes[i][k] = 2*sgr.Nodes[i1][k]-sgr.Nodes[i2][k];
		}
		if((col==0)&&(row!=0)&&(row!=sgr.rowCount-1)){
			int i1 = i+1;
			int i2 = i+2;
			for(int k=0;k<dimension;k++) sgr.Nodes[i][k] = 2*sgr.Nodes[i1][k]-sgr.Nodes[i2][k];
		}
		if((col==sgr.colCount-1)&&(row!=0)&&(row!=sgr.rowCount-1)){
			int i1 = i-1;
			int i2 = i-2;
			for(int k=0;k<dimension;k++) sgr.Nodes[i][k] = 2*sgr.Nodes[i1][k]-sgr.Nodes[i2][k];
		}
	}
	i = 0;
	int i1 = sgr.colCount+1;
	int i2 = 1;
	int i3 = sgr.colCount;
	for(int k=0;k<dimension;k++) sgr.Nodes[i][k] = -sgr.Nodes[i1][k]+sgr.Nodes[i2][k]+sgr.Nodes[i3][k];

	i = sgr.colCount-1;
	i1 = i+sgr.colCount-1;
	i2 = i+sgr.colCount;
	i3 = i-1;
	for(k=0;k<dimension;k++) sgr.Nodes[i][k] = -sgr.Nodes[i1][k]+sgr.Nodes[i2][k]+sgr.Nodes[i3][k];

	i = sgr.colCount*(sgr.rowCount-1);
	i1 = i-sgr.colCount+1;
	i2 = i-sgr.colCount;
	i3 = i+1;
	for(k=0;k<dimension;k++) sgr.Nodes[i][k] = -sgr.Nodes[i1][k]+sgr.Nodes[i2][k]+sgr.Nodes[i3][k];

	i = sgr.colCount*sgr.rowCount-1;
	i1 = i-sgr.colCount-1;
	i2 = i-sgr.colCount;
	i3 = i-1;
	for(k=0;k<dimension;k++) sgr.Nodes[i][k] = -sgr.Nodes[i1][k]+sgr.Nodes[i2][k]+sgr.Nodes[i3][k];
	free();
	nodesNum = sgr.nodesNum;
	edgesNum = sgr.edgesNum;
	ribsNum = sgr.ribsNum;
	trianglesNum = sgr.trianglesNum;
	colCount = sgr.colCount;
	rowCount = sgr.rowCount;
	allocate();
	copyfrom(sgr);
}

void SimpleRectangularGrid::interpolate(){
	
}

SphericalGrid::SphericalGrid(int cols, int rows, int dim){
	rowCount = rows;
	colCount = cols;
	dimension = dim;
	type = 1;
	generate();
}

void SphericalGrid::generate(){

  nodesNum = colCount*rowCount+2;
  int pol1 = nodesNum-2;
  int pol2 = nodesNum-1;
  edgesNum = 2*colCount*rowCount-colCount-rowCount + 2*colCount+rowCount;
  int cc = (int)((double)colCount/2.0);
  ribsNum = 2*(colCount*rowCount-colCount-rowCount) + 2*colCount+2*rowCount+2*cc;
  trianglesNum = 2*(rowCount-1)*(colCount-1) + 2*(colCount-1)+2+2*(rowCount-1);
  intDim = 2;

  allocate();

  float th,fi;
  for(int i=0;i<colCount;i++)
	  for(int j=0;j<rowCount;j++){
	      th=(float)(3.1415926/(rowCount+1)*(j+1));
		  fi=(float)(2*3.1415926/(colCount)*(i));
		  
	      Nodes3D[i*rowCount+j][0]=(float)(sin(th)*cos(fi));
		  Nodes3D[i*rowCount+j][1]=(float)(sin(th)*sin(fi));
		  Nodes3D[i*rowCount+j][2]=(float)cos(th);
	  }
  Nodes3D[pol1][0] = 0;
  Nodes3D[pol1][1] = 0;
  Nodes3D[pol1][2] = 1;
  Nodes3D[pol2][0] = 0;
  Nodes3D[pol2][1] = 0;
  Nodes3D[pol2][2] = -1;


  int k=0;
  for(i=0;i<rowCount;i++)
     for(int j=0;j<colCount;j++) {
      if(j<colCount-1) {
       Edges[k][0]=colCount*i+j;
       Edges[k][1]=colCount*i+j+1;
       k++;
      }
      if(i<rowCount-1) {
       Edges[k][0]=i*colCount+j;
       Edges[k][1]=(i+1)*colCount+j;
       k++;
      }
     }
  for(i=0;i<colCount;i++)
  {
    Edges[k][0]=pol1;
    Edges[k][1]=i*rowCount;
    k++;
    Edges[k][0]=pol2;
    Edges[k][1]=i*rowCount+colCount-1;
    k++;
  }
  for( i=0;i<rowCount;i++)
  {
    Edges[k][0]=i;
    Edges[k][1]=(colCount-1)*rowCount+i;
    k++;
  }

   k=0;
   for(i=0;i<rowCount;i++)
    for(int j=0;j<colCount;j++) {
       if(j<colCount-2) {
        Ribs[k][0]=colCount*i+j+1;
        Ribs[k][1]=colCount*i+j;
        Ribs[k][2]=colCount*i+j+2;
        k++;
       }
       if(i<rowCount-2) {
        Ribs[k][0]=(i+1)*colCount+j;
        Ribs[k][1]=i*colCount+j;
        Ribs[k][2]=(i+2)*colCount+j;
        k++;
       }
      }

  for(i=0;i<colCount;i++)
    {
    Ribs[k][0] = i*rowCount;
    Ribs[k][1] = pol1;
    Ribs[k][2] = i*rowCount+1;
    k++;
    Ribs[k][0] = i*rowCount+colCount-1;
    Ribs[k][1] = pol2;
    Ribs[k][2] = i*rowCount+colCount-2;
    k++;
    };
  for(i=0;i<rowCount;i++)
    {
    Ribs[k][0] = i;
    Ribs[k][1] = rowCount+i;
    Ribs[k][2] = (colCount-1)*rowCount+i;
    k++;
    Ribs[k][0] = (colCount-1)*rowCount+i;
    Ribs[k][1] = (colCount-2)*rowCount+i;
    Ribs[k][2] = i;
    k++;
    };
  for(i=0;i<cc;i++)
    {
    Ribs[k][0] = pol1;
    Ribs[k][1] = i*rowCount;
    Ribs[k][2] = (i+cc)*rowCount;
    k++;
    Ribs[k][0] = pol2;
    Ribs[k][1] = i*rowCount+colCount-1;
    Ribs[k][2] = (i+cc)*rowCount+colCount-1;
    k++;
    };

    k=0;
    for(i=0;i<colCount-1;i++)
     for(int j=0;j<rowCount-1;j++) {
      Triangles[k][0]=colCount*j+i;
      Triangles[k][1]=colCount*j+i+1;
      Triangles[k][2]=colCount*(j+1)+i;
      k++;
      Triangles[k][0]=colCount*(j+1)+i+1;
      Triangles[k][1]=colCount*j+i+1;
      Triangles[k][2]=colCount*(j+1)+i;
      k++;
     }
  for(i = 0;i<colCount-1;i++)
    {
    Triangles[k][0] = i*rowCount;
    Triangles[k][1] = pol1;
    Triangles[k][2] = (i+1)*rowCount;
    k++;
    Triangles[k][0] = i*rowCount+colCount-1;
    Triangles[k][1] = pol2;
    Triangles[k][2] = (i+1)*rowCount+colCount-1;
    k++;
    }
  for(i = 0;i<rowCount-1;i++)
    {
    Triangles[k][0] = i;
    Triangles[k][1] = i+1;
    Triangles[k][2] = (colCount-1)*rowCount+i+1;
    k++;
    Triangles[k][0] = i;
    Triangles[k][1] = (colCount-1)*rowCount+i;
    Triangles[k][2] = (colCount-1)*rowCount+i+1;
    k++;
    }
    Triangles[k][0] = (colCount-1)*rowCount;
    Triangles[k][1] = pol1;
    Triangles[k][2] = 0;
    k++;
    Triangles[k][0] = (colCount-1)*rowCount+rowCount-1;
    Triangles[k][1] = pol2;
    Triangles[k][2] = rowCount-1;
    k++;

fixEElasticity(0);
fixRElasticity(0);

}

LinearGrid::LinearGrid(int points, int dim){
	pointCount = points;
	dimension = dim;
	intDim = 1;
	type = 2;
	generate();
}

void LinearGrid::generate(){
	nodesNum = pointCount;
	edgesNum = pointCount-1;
	ribsNum = pointCount - 2;
	trianglesNum = 0;
	allocate();	
	for(int i=0;i<pointCount;i++){
		double x = 2*(double)i/pointCount-1;
		Nodes3D[i][0] = (float)x;
		Nodes3D[i][1] = 0;
		Nodes3D[i][2] = 0;
	}
	for(i=0;i<pointCount-1;i++){
		Edges[i][0] = i;
		Edges[i][1] = i+1;
	}
	for(i=1;i<pointCount-1;i++){
		Ribs[i-1][0] = i;
		Ribs[i-1][1] = i-1;
		Ribs[i-1][2] = i+1;
	}
}

void LinearGrid::extrapolate(){
}
void LinearGrid::interpolate(){
}

void Grid::adaptateGrow(vector<vector<int> > taxons, int degree){
	vector<int> maxedge;
	vector<int> maxedgew;
	for(int k=0;k<degree;k++){
		maxedge.push_back(-1);
		maxedgew.push_back(-1);
	}
	for(int i=0;i<edgesNum;i++){
		int i1 = Edges[i][0]; 
		int i2 = Edges[i][1]; 
		int wei = taxons[i1].size()+taxons[i2].size();
		int mine = -1;
		int minv = 10000000;
		for(k=0;k<degree;k++){
			if(maxedgew[k]<minv) { minv = maxedgew[k]; mine = k; }
		}
		if(wei>minv) { maxedgew[mine] = wei; maxedge[mine] = i; };
	}
	for(i=0;i<degree;i++)
		divideEdgeInHalf(maxedge[i],0);
}

void Grid::adaptateBreak(vector<vector<int> > taxons,Dataset *dat){
	double *mas = new double[nodesNum];
	getDistancesToCentroids(mas,dat,taxons);
	double mean,std;
	calcSimpleStatistics(mas,nodesNum,mean,std);
	vector<int> nds;
	for(int i=0;i<nodesNum;i++){
		if(mas[i]>mean+2*std)
			nds.push_back(i);
	}
	//printf("Mean = %f, Std = %f, %i nodes selected\n",mean,std,nds.size());
	for(i=0;i<ribsNum;i++){
		for(int j=0;j<nds.size();j++)
			if(Ribs[i][0]==nds[j]){
				RP[i]*=mean/mas[nds[j]];
			}
	}
	delete [] mas;
}

void Grid::makeConnectList(){
	connectList.clear();
	for(int i=0;i<nodesNum;i++){
		vector<int> v;
		for(int j=0;j<edgesNum;j++){
			if((Edges[j][0]==i)||(Edges[j][1]==i))
				v.push_back(j);
		}
		connectList.push_back(v);
	}
}

void Grid::connectGraph(){
	makeConnectList();
	double *mas = new double[nodesNum];
	vector<vector<int> > newEdges;
	for(int i=0;i<nodesNum;i++){
		double mind = MAX_VALUE;
		int k = -1;
		for(int j=0;j<nodesNum;j++) if(i!=j) {
			double r = 0;
			for(int ii=0;ii<dimension;ii++) r+=(Nodes[i][ii]-Nodes[j][ii])*(Nodes[i][ii]-Nodes[j][ii]);
			if(r<mind) { 
				bool conn = false;
				//printf("For i = %i connectList[i].size = %i\n",i,connectList[i].size());
				for(ii = 0;ii<connectList[i].size();ii++){
					//printf("%i \n",connectList[i][j]);
					if((Edges[connectList[i][ii]][0]==j)||(Edges[connectList[i][ii]][1]==j))
						conn = true;
				}
				if(!conn)
					{mind = r; k = j;}
			}
		}
		if(k!=-1){
			vector<int> v;
			v.push_back(i); v.push_back(k);
			newEdges.push_back(v);
			mas[i] = sqrt(mind);
			}
		else
			mas[i] = 0;
	}
	double mean,std;
	calcSimpleStatistics(mas,nodesNum,mean,std);

	FILE *f;
	f = fopen("mas","w");
	fprintf(f,"Mean = %f  Std = %f\n",mean,std);
	for(i=0;i<nodesNum;i++){
		fprintf(f,"%f\n",mas[i]);
	}

	i = 0;
	while(true){
		double r = 0;
		for(int ii=0;ii<dimension;ii++){
			double d = Nodes[newEdges[i][0]][ii]-Nodes[newEdges[i][1]][ii];
			r+=d*d;
		}
		if(sqrt(r)>mean+4*std){
			newEdges.erase(newEdges.begin()+i);
			fprintf(f,"Excluded (r=%f) ",sqrt(r));
		}
		else
			i++;
		if(i>=newEdges.size()-1) break;
	}
	for(i=0;i<newEdges.size();i++){
		for(int kk=0;kk<2;kk++){
		int i1 = newEdges[i][kk];
		int i2 = newEdges[i][1-kk];
		for(int j=0;j<connectList[i1].size();j++){
			for(int k=0;k<2;k++)
			if(Edges[connectList[i1][j]][k]!=i1){
				vector<int> r;
				r.push_back(i1); r.push_back(Edges[connectList[i1][j]][k]); r.push_back(i2);
				Ribs.push_back(r);
				RP.push_back(1);
			}
		}}

		Edges.push_back(newEdges[i]);
		EP.push_back(1);
	}
	fixRElasticity(1);
	fclose(f);
	edgesNum = Edges.size();
	ribsNum = Ribs.size();
	delete [] mas;
}

CircleGrid::CircleGrid(int points, int dim){
	pointCount = points;
	dimension = dim;
	intDim = 1;
	type = 3;
	generate();
}
void CircleGrid::generate(){

	nodesNum = pointCount;
	edgesNum = pointCount;
	ribsNum = pointCount;
	trianglesNum = 0;
	allocate();	
	for(int i=0;i<pointCount;i++){
		double x = 2*3.1415926*(double)i/pointCount;
		Nodes3D[i][0] = (float)cos(x);
		Nodes3D[i][1] = (float)sin(x);
		Nodes3D[i][2] = (float)0;
	}
	for(i=0;i<pointCount-1;i++){
		Edges[i][0] = i;
		Edges[i][1] = i+1;
	}
	Edges[pointCount-1][0] = pointCount-1;
	Edges[pointCount-1][1] = 0;
	for(i=1;i<pointCount-1;i++){
		Ribs[i-1][0] = i;
		Ribs[i-1][1] = i-1;
		Ribs[i-1][2] = i+1;
	}
	Ribs[pointCount-2][0] = pointCount-1;
	Ribs[pointCount-2][1] = pointCount-2;
	Ribs[pointCount-2][2] = 0;
	Ribs[pointCount-1][0] = 0;
	Ribs[pointCount-1][1] = pointCount-1;
	Ribs[pointCount-1][2] = 1;
}

double Grid::calcMSE(Dataset *data, vector<vector<int> > taxons){

	double *vec = new double[dimension];

	double d = 0;
	for(int i=0;i<nodesNum;i++){
		
		for(int k=0;k<dimension;k++) vec[k] = 0;
		for(int j=0;j<taxons[i].size();j++){
			for(int k=0;k<dimension;k++){
				vec[k]+=data->mas[taxons[i][j]][k];
			}
		}
		if(taxons[i].size()>0)
			for(int k=0;k<dimension;k++) vec[k] = vec[k]/taxons[i].size();
		for(j=0;j<taxons[i].size();j++){
			d+=squareEuclDistance(data->getVector(taxons[i][j]),vec,dimension);			
		}
	}
	return sqrt(d/data->pointCount);
}


void Grid::calcTaxons(vector<vector<int> > &taxons, Dataset *data){

	if(taxons.size()>0){
		for(int j=0;j<taxons.size();j++){
			taxons[j].clear();
		}
	}

	taxons.clear();
	for(int j=0;j<nodesNum;j++){
		vector<int> v;
		taxons.push_back(v);
		//for(int k=0;k<100;k++)
		//	taxons[j].push_back(k);
	}
	float r = 0;
	//float *v2 = new float[data->coordCount];

	int dimen = data->coordCount;
	
	
	for(int i=0;i<data->pointCount;i++){
		float *v = data->getVector(i);
		float minr = (float)MAX_VALUE;
		int minj = -1;
		for(int j=0;j<nodesNum;j++){
			//for(int k=0;k<data->coordCount;k++) v2[k] = Nodes[j][k];
			//float *v2 = NodesCopy2[j];
			//float r = squareEuclDistance(v2,v,data->coordCount);
			     r = squareEuclDistance(NodesCopy,j*dimen,v,data->coordCount);
			//float r = squareEuclDistance(NodesCopy2[j],v,data->coordCount);;
			//r = 0;
			//for(int kk=0;kk<dimen;kk++) r+=(v[kk]-v2[kk])*(v[kk]-v2[kk]);

			/*r = 0;
			for(kk=0;kk<dimen;kk++){
				sf = NodesCopy[j*dimen+kk]-v[kk];
				r+=sf*sf;
			}*/

			if(r<minr){ minr=r; minj = j; }
		}
		//if(i==239) 
		//	cout << i << minr << " size " << taxons.size() << endl;
		if(minj!=-1)
			taxons[minj].push_back(i);
	}

}


ElasticGraph::ElasticGraph(int points, int dim){
	pointCount = points;
	dimension = dim;
	minNumInCluster = 5;
	intDim = 1;
	type = 4;
	generate();
}

void ElasticGraph::generate(){
	nodesNum = pointCount;
	edgesNum = 0;
	ribsNum = 0;
	trianglesNum = 0;
	allocate();	
}

void ElasticGraph::KMeansInitialization(Dataset *d, int numiter, double eps){
	vector<vector<int> > taxons;
	
	d->stat->calculate(d);	
	// initialization
	for(int i=0;i<nodesNum;i++){
		for(int k=0;k<dimension;k++){
			float f = (float)1.0*rand()/RAND_MAX;
			f = d->stat->Mins[k] + (d->stat->Maxs[k]-d->stat->Mins[k])*f;
			Nodes[i][k] = f;
			if(k<3)
				Nodes3D[i][k] = f;
		}
	}
	// main cycle

	/*for(int k=0;k<Nodes.size();k++){
			cout << "Node " << k << " : ";
			for(int j=0;j<dimension;j++) 
				cout << Nodes[k][j] << " ";
			cout << endl;
		}*/

	for(i=0;i<numiter;i++){
		MakeNodesCopy();
		calcTaxons(taxons,d);
		/*for(int kk=0;kk<taxons.size();kk++){
			cout << "Taxon " << kk << " : ";
			for(int j=0;j<taxons[kk].size();j++) 
				cout << taxons[kk][j] << " ";
			cout << endl;
		}*/
		Nodes.clear();
		for(int k=0;k<taxons.size();k++){
			vector<float> vf;
			for(int l=0;l<dimension;l++){
				float f = 0;
				for(int j=0;j<taxons[k].size();j++){
					f+=d->mas[taxons[k][j]][l];
				}
				if(taxons[k].size()==0){
					f = (float)1.0*rand()/RAND_MAX;
					f = d->stat->Mins[l] + (d->stat->Maxs[l]-d->stat->Mins[l])*f;
				}else
					f/=taxons[k].size();
				vf.push_back(f);
			}
			Nodes.push_back(vf);
		}
	}
	// clear empties
	MakeNodesCopy();
	calcTaxons(taxons,d);
	int k = 0;
	//if(false)
	for(i=taxons.size()-1;i>=0;i--){
		if(taxons[i].size()<=minNumInCluster){
			//printf("erased %i, %i points\n",k,taxons[i].size());
			Nodes.erase(Nodes.begin()+i);
			Nodes3D.erase(Nodes3D.begin()+i);
			k++;
		}
	}
	nodesNum = Nodes.size();
	printf("%i nodes left.\n",nodesNum);
}

void ElasticGraph::localDipoles(Dataset *dset){
	vector<vector<int> > taxons;
	MakeNodesCopy();
	calcTaxons(taxons,dset);
	Dataset d;
	PCAMethod pc;
	pc.ds = &d;

	for(int ii=0;ii<taxons.size();ii++){
		//printf("Taxon %i: %i\n",ii,taxons[ii].size());
		//for(int jj=0;jj<taxons[ii].size();jj++)
		//	printf("%i ",taxons[ii][jj]);
		//printf("\n");
	}

	for(int i=0;i<taxons.size();i++) {
		Grid* gr = new Grid;
		//sprintf(gr->name,"Grid for taxon %i ",i);
		subgrids.push_back(*gr);
	}

	for(i=0;i<taxons.size();i++){ 
		
		//printf("Tax: %i pointCount = %i \n",i,taxons[i].size());

		if(taxons[i].size()>=2) {
		d.pointCount = taxons[i].size();
		
		d.coordCount = dimension;
		d.mas = new float*[d.pointCount];
		for(int j=0;j<taxons[i].size();j++){
				d.mas[j] = dset->getVector(taxons[i][j]);
		}
		pc.silent = true;
		pc.calc(1);
		//pc.calcDispersions();
		double disp = sqrt(pc.dispersions[0]/dset->stat->totalDispersion);
		disp*=1.5;
		//printf("Total disp: %f disp %f x[0]=%f x[1]=%f\n",dset->stat->totalDispersion,disp,pc.comps[0][0],pc.comps[0][1]);
		vector<float> n1; vector<float> n2;
		vector<float> n13; vector<float> n23;
		for(int k=0;k<dimension;k++){
			n1.push_back(pc.Shift[k]+disp*pc.comps[0][k]);
			n2.push_back(pc.Shift[k]-disp*pc.comps[0][k]);			
			n13.push_back(pc.Shift[k]+disp*pc.comps[0][k]);
			n23.push_back(pc.Shift[k]-disp*pc.comps[0][k]);			
		}
		subgrids[i].Nodes.push_back(n1); subgrids[i].Nodes.push_back(n2);
		if(dimension<3) { n13.push_back(0); n23.push_back(0); }
		subgrids[i].Nodes3D.push_back(n13); subgrids[i].Nodes3D.push_back(n23);
		vector<int> ed;
		ed.push_back(0); ed.push_back(1);
		subgrids[i].Edges.push_back(ed);
		subgrids[i].EP.push_back(1);
		subgrids[i].nodesNum = subgrids[i].Nodes.size();
		subgrids[i].edgesNum = 1;
		subgrids[i].ribsNum = 0;
		subgrids[i].trianglesNum = 0;
		delete [] d.mas;
		d.mas = NULL;
    }else{

	}
	}
	//printf("finish\n");
}

void ElasticGraph::synchronize(){
	free();
	for(int i=0;i<subgrids.size();i++){
		Grid *gr = &(subgrids[i]);
		int numn = Nodes.size();
		for(int k=0;k<gr->Nodes.size();k++){
			Nodes.push_back(gr->Nodes[k]);
			Nodes3D.push_back(gr->Nodes3D[k]);
		}
		for(k=0;k<gr->Edges.size();k++){
			vector<int> ed;
			ed.push_back(gr->Edges[k][0]+numn);
			ed.push_back(gr->Edges[k][1]+numn);
			Edges.push_back(ed);
			EP.push_back(gr->EP[k]);
		}
		for(k=0;k<gr->Ribs.size();k++){
			vector<int> rib;
			rib.push_back(gr->Ribs[k][0]+numn);
			rib.push_back(gr->Ribs[k][1]+numn);
			rib.push_back(gr->Ribs[k][2]+numn);
			Ribs.push_back(rib);
			RP.push_back(gr->RP[k]);
		}
		for(k=0;k<gr->Triangles.size();k++){
			vector<int> tr;
			tr.push_back(gr->Triangles[k][0]+numn);
			tr.push_back(gr->Triangles[k][1]+numn);
			tr.push_back(gr->Triangles[k][2]+numn);
			Ribs.push_back(tr);
		}
	}
		nodesNum = Nodes.size();
		edgesNum = Edges.size();
		ribsNum = Ribs.size();
		trianglesNum = Triangles.size();
}


void LinearGrid::saveInNaturalOrder(char *fn){
	FILE *f;
	f = fopen(fn,"w");
	if(f!=NULL){
	int firstnode = -1;
	for(int i=0;i<Nodes.size();i++){
		int k0 = 0; int k1 = 0;
		for(int j=0;j<Edges.size();j++){
			if(Edges[j][0]==i) k0++;
			if(Edges[j][1]==i) k1++;
		}
		if((k0==1)&&(k1==0)) { firstnode = i; break; }
	}
	int k = 0; 
	while(true){
		for(int j=0;j<dimension;j++) fprintf(f,"%f\t",Nodes[firstnode][j]); fprintf(f,"\n");
		if(k<0) break;
		k = -1;
		for(j=0;j<Edges.size();j++){
			if(Edges[j][0]==firstnode) { cout << Edges[j][0] << " " << Edges[j][1] << endl; firstnode = Edges[j][1]; k=j;  break; }
		}
	}
	fclose(f);
	}else{
		cout << "Can not open for writing: " << fn << endl;
	}

}

void ElasticGraph::test(Dataset *ds){
}


