#include "stdafx.h"

#include "compcol_double.h"
#include "icpre_double.h"

#include "sparseadpt.h"

class SparseAdapter;

class SLAUSolver{ // Simple adapter
	
public:

	double *solution;
	double *vector;
	MV_Vector_double *solution_v;
	MV_Vector_double *vector_v;
	int dimension;

	SLAUSolver(){
		solution = NULL;
		vector = NULL;
		solution_v = NULL;
		vector_v = NULL;
		Matrix = NULL;
		Preconditioner = NULL;
	}
	~SLAUSolver(){
		if(solution!=NULL) delete [] solution;
		if(vector!=NULL) delete [] vector;
		if(solution_v!=NULL) delete solution_v;
		if(vector_v!=NULL) delete vector_v;
		if(Matrix!=NULL) delete Matrix;
		if(Preconditioner!=NULL) delete Preconditioner;
	}

	void readMatrix(char *);
	void saveMatrix(char *);
	void readVector(char *);
	void saveVector(char *);
	void setVector(double *);
	void setSolution(double *);
	void saveSolution(char *);

	SparseAdapter sparseAdapter;
	CompCol_Mat_double *Matrix;
	ICPreconditioner_double *Preconditioner;
	void initMatrix();
	void setMatrixElement(int,int,double);
	double getMatrixElement(int,int);
	double addToMatrixElement(int,int,double);
	void createMatrix();
	void createPreconditioner();
	
	long solve(double,int); // >0 - clocks spent, -1 - failed because of ... 

};