#include "stdafx.h"
#include <stdlib.h>
#include <math.h>
#include <map.h>

#include "sparseadpt.h"

void SparseAdapter::put(int i,int j,double v){
	pair<int,int> p(i,j);
	cells[p] = v;
}

double SparseAdapter::get(int i,int j){
	pair<int,int> p(i,j);
	return cells[p];
}

double SparseAdapter::add(int i,int j,double v){
	double p = get(i,j);
	put(i,j,p+v);
	return p+v;
}

void SparseAdapter::clear(){
	cells.clear();
}

void SparseAdapter::getElements(int *is,int *js,double *val){
	typedef pair<int,int> pint;
	typedef map<pair<int,int> , double> mpi;
	mpi::iterator it;
	int n = getSize();
	it = cells.begin();
	for(int i=0;i<n;i++){
		pint p = (*it).first;
		is[i] = p.first;
		js[i] = p.second;
		val[i] = (*it).second;
		++it;
	}
}

int SparseAdapter::getSize(){
	return cells.size();
}