#include "stdafx.h"
#include <stdlib.h>
#include <math.h>
#include "utils.h"

#define Min3(x,y,z) min(x,min(y,z))

void randomVector(double *v,int dimen){
	for(int i=0;i<dimen;i++) 
		v[i] = (double)(1.0*rand()/33000);
		
	double s = 0;
	for(i=0;i<dimen;i++) s+=v[i]*v[i];
	for(i=0;i<dimen;i++) v[i]/=sqrt(s);

}

double vectorNorm(double *v,int dimen){
double s = 0;
for(int i=0;i<dimen;i++) s+=v[i]*v[i];
return sqrt(s);
}
float vectorNorm(float *v,int dimen){
double s = 0;
for(int i=0;i<dimen;i++) s+=v[i]*v[i];
return (float)sqrt(s);
}


double scalarProduct(float *v1,float *v2,int dimen){

double s = 0;
for(int i=0;i<dimen;i++) s+=v1[i]*v2[i];
return s;

}

inline void subtract(float *v1,float *v2,float *sv, int dimen){
	for(int i=0;i<dimen;i++) sv[i] = v1[i]-v2[i];
}

double euclDistance(double *v1,double*v2,int dimen){
double s = 0;
for(int i=0;i<dimen;i++) s+=(v1[i]-v2[i])*(v1[i]-v2[i]);
return sqrt(s);
}

 
double squareEuclDistance(double *v1,double*v2,int dimen){
double s = 0;
for(int i=0;i<dimen;i++) s+=(v1[i]-v2[i])*(v1[i]-v2[i]);
return s;
}

double squareEuclDistance(float *v1,double*v2,int dimen){
double s = 0;
for(int i=0;i<dimen;i++) s+=(v1[i]-v2[i])*(v1[i]-v2[i]);
return s;
}


double squareEuclDistance(double *v1,float*v2,int dimen){
double s = 0;
for(int i=0;i<dimen;i++) s+=(v1[i]-v2[i])*(v1[i]-v2[i]);
return s;
}

float squareEuclDistance(float *v1,float*v2,int dimen){
float s = 0;
for(int i=0;i<dimen;i++) s+=(v1[i]-v2[i])*(v1[i]-v2[i]);
return s;
}

double squareEuclDistance(vector<float> v1,float*v2,int dimen){
double s = 0;
for(int i=0;i<dimen;i++) s+=(v1[i]-v2[i])*(v1[i]-v2[i]);
return s;
}

float squareEuclDistance(float *v1,int shift,float*v2,int dimen){
float s = 0;
int i = 1;
register float sf = 0;
for(i=0;i<dimen;i++) {
	sf = v1[i+shift]-v2[i];
	s+= sf*sf;
}
return s;
}

float projectOnSegment(float *point, float *p1, float *p2, int dimen, float &u){
	float m = 0, s = 0;
	u = 0;
	for(int i=0;i<dimen;i++){
		m = p2[i]-p1[i];
		u+=(point[i]-p1[i])*m;
		s+=m*m;
	}
	u/=s;
	if(u<0) u = 0;
	if(u>1) u = 1;
	s = 0;
	for(i=0;i<dimen;i++){
		s+=(point[i]-(p1[i]+u*(p2[i]-p1[i])));
	}
	return s;
}

void coordinatesInBasis2D(float *point, float *p1, float *p2, float *p3, int dimen, float &u, float &v){
	float m = 0, n = 0, mn = 0, m2 = 0, n2 = 0, xrm = 0, xrn = 0, den = 0;
	for(int i=0;i<dimen;i++){
		m = p2[i] - p1[i];
		n = p3[i] - p1[i];
		mn+=m*n;
		m2+=m*m;
		n2+=n*n;
		xrm+=(point[i]-p1[i])*m;
		xrn+=(point[i]-p1[i])*n;
	}
	den=m2*n2-mn*mn;
	if(den<1e-8) den=(float)1e-8;
	u = (xrm*n2-mn*xrn)/den;
	v = (xrn*m2-mn*xrm)/den;
}

float projectOnTriangle(float *point, float *p1, float *p2, float *p3, int dimen, float &u, float &v){
 float res = 0, m = 0, n = 0, mn = 0, m2 = 0, n2 = 0, den = 0, xrn =0, xrm = 0, tmp = 0;
 float u1 = 0, u2 = 0, u3 = 0;
 for(int i=0;i<dimen;i++){
	 m = p2[i] - p1[i];
	 n = p3[i] - p1[i];
	 mn+=m*n;
	 m2+=m*m;
	 n2+=n*n;
	 xrn+=(point[i]-p1[i])*n;
	 xrm+=(point[i]-p1[i])*m;
 }
 den=m2*n2-mn*mn;
 if(den<1e-8) den = (float)1e-8;
 u=(xrm*n2-mn*xrn)/den;
 v=(xrn*m2-mn*xrm)/den;
 if((u>=0)&&(v>=0)&&((u+v)<=1)){
   res=0;
 }else{
	float r1=projectOnSegment(point,p1,p2,dimen,u1);
	float r2=projectOnSegment(point,p1,p3,dimen,u2);
	float r3=projectOnSegment(point,p3,p2,dimen,u3);
	if(Min3(r1,r2,r3)==r1){
      v=0; u=u1;
	}else if(Min3(r1,r2,r3)==r2){
      u=0; v=u2;
	} else if(Min3(r1,r2,r3)==r3){
	  float *pt = new float[dimen];
	  for(i=0;i<dimen;i++) pt[i] = (p3[i] - p2[i])*u3;
	  coordinatesInBasis2D(pt,p1,p2,p3,dimen,u,v);
	  delete [] pt;
    }
	res = 0;
	for(i=0;i<dimen;i++){
		tmp =(point[i] - (p1[i] + (p2[i]-p1[i])*u + (p3[i]-p1[i])*v));
		res+=tmp*tmp;
	}
 }
 return res;
}

void calcSimpleStatistics(double *mas, int n, double &mean, double &std){
	mean = 0;
	std = 0;
	for(int i=0;i<n;i++){
		mean+=mas[i];
		std+=mas[i]*mas[i];
	}
	mean/=n;
	std = sqrt(std/n-mean*mean);
}